/*
 * Licensed under the terms of the GNU GENERAL PUBLIC LICENSE version 2.
 * See file COPYING for details.
 */

#ifndef fam10h_h
#define fam10h_h

#include "../msr.h"

_RANGE(fam10h_LSMCAaddr,48,16,0);
_NAMES(fam10h_LSMCAaddr,"ADDR",0);
_RANGE(fam10h_LSMCAstatus,16,4,25,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(fam10h_LSMCAstatus,"ErrorCode","ErrorCodeExt",0,"UECC","CECC","SYND",0,"PCC","ADDRV","MISCV","EN","UC","OVER","VAL");
_RANGE(fam10h_TSC,64,0);
_NAMES(fam10h_TSC,"TSC");
_RANGE(fam10h_APIC_BASE,8,1,2,1,36,16,0);
_NAMES(fam10h_APIC_BASE,0,"BSC",0,"ApicEn","ApicBar",0);
_RANGE(fam10h_EBL_CR_POWERON,16,2,46,0);
_NAMES(fam10h_EBL_CR_POWERON,0,"ClusterID",0);
_RANGE(fam10h_PATCH_LEVEL,32,32,0);
_NAMES(fam10h_PATCH_LEVEL,"PATCH_LEVEL",0);
_RANGE(fam10h_MTRRcap,8,1,1,1,53,0);
_NAMES(fam10h_MTRRcap,"MtrrCapVCnt","MtrrCapFix",0,"MtrrCapWc",0);
_RANGE(fam10h_SYSENTER_CS,16,48,0);
_NAMES(fam10h_SYSENTER_CS,"SYSENTER_CS",0);
_RANGE(fam10h_SYSENTER_ESP,32,32,0);
_NAMES(fam10h_SYSENTER_ESP,"SYSENTER_ESP",0);
_RANGE(fam10h_SYSENTER_EIP,32,32,0);
_NAMES(fam10h_SYSENTER_EIP,"SYSENTER_EIP",0);
_RANGE(fam10h_MCG_CAP,8,1,55,0);
_NAMES(fam10h_MCG_CAP,"Count","MCG_CTL_P",0);
_RANGE(fam10h_MCG_STAT,1,1,1,61,0);
_NAMES(fam10h_MCG_STAT,"RIPV","EIPV","MCIP",0);
_RANGE(fam10h_MCG_CTL,1,1,1,1,1,1,58,0);
_NAMES(fam10h_MCG_CTL,"DCE","ICE","BUE","LSE","NBE","FRE",0);
_RANGE(fam10h_DBG_CTL_MSR,1,1,1,1,1,1,58,0);
_NAMES(fam10h_DBG_CTL_MSR,"LBR","BTF","PB0","PB1","PB2","PB3",0);
_RANGE(fam10h_BR_FROM,64,0);
_NAMES(fam10h_BR_FROM,"LastBranchFromIP");
_RANGE(fam10h_BR_TO,64,0);
_NAMES(fam10h_BR_TO,"LastBranchToIP");
_RANGE(fam10h_LastExceptionFromIP,64,0);
_NAMES(fam10h_LastExceptionFromIP,"LastIntFromIP");
_RANGE(fam10h_LastExceptionToIP,64,0);
_NAMES(fam10h_LastExceptionToIP,"LastIntToIP");
_RANGE(fam10h_MTRRphysBase0,8,4,36,16,0);
_NAMES(fam10h_MTRRphysBase0,"MemType",0,"PhyBase",0);
_RANGE(fam10h_MTRRphysMask0,11,1,36,16,0);
_NAMES(fam10h_MTRRphysMask0,0,"Valid","PhysMask",0);
_RANGE(fam10h_MTRRphysBase1,8,4,36,16,0);
_NAMES(fam10h_MTRRphysBase1,"MemType",0,"PhyBase",0);
_RANGE(fam10h_MTRRphysMask1,11,1,36,16,0);
_NAMES(fam10h_MTRRphysMask1,0,"Valid","PhysMask",0);
_RANGE(fam10h_MTRRphysBase2,8,4,36,16,0);
_NAMES(fam10h_MTRRphysBase2,"MemType",0,"PhyBase",0);
_RANGE(fam10h_MTRRphysMask2,11,1,36,16,0);
_NAMES(fam10h_MTRRphysMask2,0,"Valid","PhysMask",0);
_RANGE(fam10h_MTRRphysBase3,8,4,36,16,0);
_NAMES(fam10h_MTRRphysBase3,"MemType",0,"PhyBase",0);
_RANGE(fam10h_MTRRphysMask3,11,1,36,16,0);
_NAMES(fam10h_MTRRphysMask3,0,"Valid","PhysMask",0);
_RANGE(fam10h_MTRRphysBase4,8,4,36,16,0);
_NAMES(fam10h_MTRRphysBase4,"MemType",0,"PhyBase",0);
_RANGE(fam10h_MTRRphysMask4,11,1,36,16,0);
_NAMES(fam10h_MTRRphysMask4,0,"Valid","PhysMask",0);
_RANGE(fam10h_MTRRphysBase5,8,4,36,16,0);
_NAMES(fam10h_MTRRphysBase5,"MemType",0,"PhyBase",0);
_RANGE(fam10h_MTRRphysMask5,11,1,36,16,0);
_NAMES(fam10h_MTRRphysMask5,0,"Valid","PhysMask",0);
_RANGE(fam10h_MTRRphysBase6,8,4,36,16,0);
_NAMES(fam10h_MTRRphysBase6,"MemType",0,"PhyBase",0);
_RANGE(fam10h_MTRRphysMask6,11,1,36,16,0);
_NAMES(fam10h_MTRRphysMask6,0,"Valid","PhysMask",0);
_RANGE(fam10h_MTRRphysBase7,8,4,36,16,0);
_NAMES(fam10h_MTRRphysBase7,"MemType",0,"PhyBase",0);
_RANGE(fam10h_MTRRphysMask7,11,1,36,16,0);
_NAMES(fam10h_MTRRphysMask7,0,"Valid","PhysMask",0);
_RANGE(fam10h_MTRRfix64K_00000,8,8,8,8,8,8,8,8,0);
_NAMES(fam10h_MTRRfix64K_00000,"0xxxxType","1xxxxType","2xxxxType","3xxxxType","4xxxxType","5xxxxType","6xxxxType","7xxxxType");
_RANGE(fam10h_MTRRfix16K_80000,8,8,8,8,8,8,8,8,0);
_NAMES(fam10h_MTRRfix16K_80000,"80xxxType","84xxxType","88xxxType","8CxxxType","90xxxType","94xxxType","98xxxType","9CxxxType");
_RANGE(fam10h_MTRRfix16K_A0000,8,8,8,8,8,8,8,8,0);
_NAMES(fam10h_MTRRfix16K_A0000,"A0xxxType","A4xxxType","A8xxxType","ACxxxType","B0xxxType","B4xxxType","B8xxxType","BCxxxType");
_RANGE(fam10h_MTRRfix4K_C0000,8,8,8,8,8,8,8,8,0);
_NAMES(fam10h_MTRRfix4K_C0000,"C0xxxType","C1xxxType","C2xxxType","C3xxxType","C4xxxType","C5xxxType","C6xxxType","C7xxxType");
_RANGE(fam10h_MTRRfix4K_C8000,8,8,8,8,8,8,8,8,0);
_NAMES(fam10h_MTRRfix4K_C8000,"C8xxxType","C9xxxType","CAxxxType","CBxxxType","CCxxxType","CDxxxType","CExxxType","CFxxxType");
_RANGE(fam10h_MTRRfix4K_D0000,8,8,8,8,8,8,8,8,0);
_NAMES(fam10h_MTRRfix4K_D0000,"D0xxxType","D1xxxType","D2xxxType","D3xxxType","D4xxxType","D5xxxType","D6xxxType","D7xxxType");
_RANGE(fam10h_MTRRfix4K_D8000,8,8,8,8,8,8,8,8,0);
_NAMES(fam10h_MTRRfix4K_D8000,"D8xxxType","D9xxxType","DAxxxType","DBxxxType","DCxxxType","DDxxxType","DExxxType","DFxxxType");
_RANGE(fam10h_MTRRfix4K_E0000,8,8,8,8,8,8,8,8,0);
_NAMES(fam10h_MTRRfix4K_E0000,"E0xxxType","E1xxxType","E2xxxType","E3xxxType","E4xxxType","E5xxxType","E6xxxType","E7xxxType");
_RANGE(fam10h_MTRRfix4K_E8000,8,8,8,8,8,8,8,8,0);
_NAMES(fam10h_MTRRfix4K_E8000,"E8xxxType","E9xxxType","EAxxxType","EBxxxType","ECxxxType","EDxxxType","EExxxType","EFxxxType");
_RANGE(fam10h_MTRRfix4K_F0000,8,8,8,8,8,8,8,8,0);
_NAMES(fam10h_MTRRfix4K_F0000,"F0xxxType","F1xxxType","F2xxxType","F3xxxType","F4xxxType","F5xxxType","F6xxxType","F7xxxType");
_RANGE(fam10h_MTRRfix4K_F8000,8,8,8,8,8,8,8,8,0);
_NAMES(fam10h_MTRRfix4K_F8000,"F8xxxType","F9xxxType","FAxxxType","FBxxxType","FCxxxType","FDxxxType","FExxxType","FFxxxType");
_RANGE(fam10h_PAT,3,5,3,5,3,5,3,5,3,5,3,5,3,5,3,5,0);
_NAMES(fam10h_PAT,"PA0MemType",0,"PA1MemType",0,"PA2MemType",0,"PA3MemType",0,"PA4MemType",0,"PA5MemType",0,"PA6MemType",0,"PA7MemType",0);
_RANGE(fam10h_MTRRdefType,8,2,1,1,52,0);
_NAMES(fam10h_MTRRdefType,"MemType",0,"MtrrDefTypeFixEn","MtrrDefTypeEn",0);
_RANGE(fam10h_MC0_CTL,1,1,1,1,1,1,1,57,0);
_NAMES(fam10h_MC0_CTL,"ECCI","ECCM","DECC","DMTP","DSTP","L1TP","L2TP",0);
_RANGE(fam10h_MC0_STATUS,16,4,4,8,8,1,4,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(fam10h_MC0_STATUS,"ErrorCode","ErrorCodeExt",0,"Syndrome",0,"Scrub",0,"UECC","CECC","Syndrome",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam10h_MC0_ADDR,48,16,0);
_NAMES(fam10h_MC0_ADDR,"ADDR",0);
_RANGE(fam10h_MC0_MISC,64,0);
_NAMES(fam10h_MC0_MISC,0);
_RANGE(fam10h_MC1_CTL,1,1,1,1,1,1,1,2,1,54,0);
_NAMES(fam10h_MC1_CTL,"ECCI","ECCM","IDP","IMTP","ISTP","L1TP","L2TP",0,"RDDE",0);
_RANGE(fam10h_MC1_STATUS,16,4,25,1,1,10,1,1,1,1,1,1,1,0);
_NAMES(fam10h_MC1_STATUS,"ErrorCode","ErrorCodeExt",0,"UECC","CECC",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam10h_MC1_ADDR,48,16,0);
_NAMES(fam10h_MC1_ADDR,"ADDR",0);
_RANGE(fam10h_MC1_MISC,64,0);
_NAMES(fam10h_MC1_MISC,0);
_RANGE(fam10h_MC2_CTL,1,1,1,1,1,1,1,1,1,1,1,1,52,0);
_NAMES(fam10h_MC2_CTL,"SRDE_HP","SRDE_TLB","SRDE_ALL","L2T_PAR","L2T_CECC","L2T_UECC","L2D_PAR","L2D_CECC","L2D_UECC",0,"VB_PAR","PDC_PAR",0);
_RANGE(fam10h_MC2_STATUS,16,4,20,1,4,1,1,10,1,1,1,1,1,1,1,0);
_NAMES(fam10h_MC2_STATUS,"ErrorCode","ErrorCodeExt",0,"Scrub",0,"UECC","CECC",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam10h_MC2_ADDR,48,16,0);
_NAMES(fam10h_MC2_ADDR,"ADDR",0);
_RANGE(fam10h_MC2_MISC,64,0);
_NAMES(fam10h_MC2_MISC,0);
_RANGE(fam10h_MC3_CTL,1,1,62,0);
_NAMES(fam10h_MC3_CTL,"SRDE_L","SRDE_S",0);
_RANGE(fam10h_MC3_STATUS,16,4,25,1,1,10,1,1,1,1,1,1,1,0);
_NAMES(fam10h_MC3_STATUS,"ErrorCode","ErrorCodeExt",0,"UECC","CECC",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam10h_MC3_ADDR,48,16,0);
_NAMES(fam10h_MC3_ADDR,"ADDR",0);
_RANGE(fam10h_MC3_MISC,64,0);
_NAMES(fam10h_MC3_MISC,0);
_RANGE(fam10h_MC4_CTL,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,36,0);
_NAMES(fam10h_MC4_CTL,"CECCEn","UECCEn","CrcErr0En","CrcErr1En","CrcErr2En","SyncPkt0En","SyncPkt1En","SyncPkt2En","MstrAbrtEn","TgtAbrtEn","GartTblWkEn","AtomicRMWEn","WDTRptEn","DevErrEn","L3ArrayCorEn","L3ArrayUCEn","HtProtEn","HtDataEn","DramParEn","RtryHt0En","RtryHt1En","RtryHt2En","RtryHt3En","CrcErr3En","SyncPkt3En","McaUsPwDatErrEn","NbArrayParEn","TblWlkDatErrEn",0);
_RANGE(fam10h_MC4_STATUS,16,5,3,8,4,1,1,1,1,1,1,2,1,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(fam10h_MC4_STATUS,"ErrorCode","ErrorCodeExt",0,"Syndrome","ErrCpu","LDTLink0","LDTLink1","LDTLink2","LDTLink3","Scrub","SubLink","McaStatSubCache",0,"UECC","CECC","Syndrome",0,"PCC","AddrV","MiscV","En","UC","Over","Val");
_RANGE(fam10h_MC4_ADDR,1,47,16,0);
_NAMES(fam10h_MC4_ADDR,0,"ErrAddr",0);
_RANGE(fam10h_MC4_MISC0,24,8,12,4,1,2,1,4,5,1,1,1,0);
_NAMES(fam10h_MC4_MISC0,0,"BlkPtr","ErrCnt",0,"Ovrflw","IntType","CntEn","LvtOffset",0,"Locked","CntP","Valid");
_RANGE(fam10h_MC5_CTL,1,63,0);
_NAMES(fam10h_MC5_CTL,"CPUWDT",0);
_RANGE(fam10h_MC5_STATUS,16,4,4,8,8,1,4,1,1,8,2,1,1,1,1,1,1,1,0);
_NAMES(fam10h_MC5_STATUS,"ErrorCode","ErrorCodeExt",0,"Syndrome",0,"Scrub",0,"UECC","CECC","Syndrome",0,"PCC","AddrV","MiscV","En","UC","OVER","VAL");
_RANGE(fam10h_MC5_ADDR,48,16,0);
_NAMES(fam10h_MC5_ADDR,"ADDR",0);
_RANGE(fam10h_MC5_MISC,12,52,0);
_NAMES(fam10h_MC5_MISC,"State",0);
_RANGE(fam10h_EFER,1,7,1,1,1,1,1,1,1,49,0);
_NAMES(fam10h_EFER,"SYSCALL",0,"LME",0,"LMA","NXE","SVME","LMSLE","FFXSE",0);
_RANGE(fam10h_STAR,32,16,16,0);
_NAMES(fam10h_STAR,"Target","SysCallSel","SysRetSel");
_RANGE(fam10h_STAR64,64,0);
_NAMES(fam10h_STAR64,"LSTAR");
_RANGE(fam10h_STARCOMPAT,64,0);
_NAMES(fam10h_STARCOMPAT,"CSTAR");
_RANGE(fam10h_SYSCALL_FLAG_MASK,32,32,0);
_NAMES(fam10h_SYSCALL_FLAG_MASK,"MASK",0);
_RANGE(fam10h_FS_BASE,64,0);
_NAMES(fam10h_FS_BASE,"FS_BASE");
_RANGE(fam10h_GS_BASE,64,0);
_NAMES(fam10h_GS_BASE,"GS_BASE");
_RANGE(fam10h_KernelGSbase,64,0);
_NAMES(fam10h_KernelGSbase,"KernelGSBase");
_RANGE(fam10h_TSC_AUX,32,32,0);
_NAMES(fam10h_TSC_AUX,"TscAux",0);
_RANGE(fam10h_MC4_MISC1,24,8,12,4,1,2,1,4,5,1,1,1,0);
_NAMES(fam10h_MC4_MISC1,0,"BlkPtr","ErrCnt",0,"Ovrflw","IntType","CntEn","LvtOffset",0,"Locked","CntP","Valid");
_RANGE(fam10h_MC4_MISC2,24,8,12,4,1,2,1,4,5,1,1,1,0);
_NAMES(fam10h_MC4_MISC2,0,"BlkPtr","ErrCnt",0,"Ovrflw","IntType","CntEn","LvtOffset",0,"Locked","CntP","Valid");
_RANGE(fam10h_MC4_MISC3,24,8,32,0);
_NAMES(fam10h_MC4_MISC3,0,"BlkPtr",0);
_RANGE(fam10h_PERF_CTL0,8,8,1,1,1,1,1,1,1,1,8,4,4,1,1,22,0);
_NAMES(fam10h_PERF_CTL0,"EventSelect","UnitMask","User","OS","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"GuestOnly","HostOnly",0);
_RANGE(fam10h_PERF_CTL1,8,8,1,1,1,1,1,1,1,1,8,4,4,1,1,22,0);
_NAMES(fam10h_PERF_CTL1,"EventSelect","UnitMask","User","OS","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"GuestOnly","HostOnly",0);
_RANGE(fam10h_PERF_CTL2,8,8,1,1,1,1,1,1,1,1,8,4,4,1,1,22,0);
_NAMES(fam10h_PERF_CTL2,"EventSelect","UnitMask","User","OS","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"GuestOnly","HostOnly",0);
_RANGE(fam10h_PERF_CTL3,8,8,1,1,1,1,1,1,1,1,8,4,4,1,1,22,0);
_NAMES(fam10h_PERF_CTL3,"EventSelect","UnitMask","User","OS","Edge",0,"Int",0,"En","Inv","CntMask","EventSelect",0,"GuestOnly","HostOnly",0);
_RANGE(fam10h_PERF_CTR0,48,16,0);
_NAMES(fam10h_PERF_CTR0,"CTR",0);
_RANGE(fam10h_PERF_CTR1,48,16,0);
_NAMES(fam10h_PERF_CTR1,"CTR",0);
_RANGE(fam10h_PERF_CTR2,48,16,0);
_NAMES(fam10h_PERF_CTR2,"CTR",0);
_RANGE(fam10h_PERF_CTR3,48,16,0);
_NAMES(fam10h_PERF_CTR3,"CTR",0);
_RANGE(fam10h_SYS_CFG,8,1,1,1,5,1,1,1,1,1,1,1,41,0);
_NAMES(fam10h_SYS_CFG,0,"SetDirtyEnE","SetDirtyEnS","SetDirtyEnO",0,"ChxToDirtyDis","SysUcLockEn","MtrrFixDramEn","MtrrFixDramModeEn","MtrrVarDramEn","MtrrTom2En","Tom2ForceMemTypeWB",0);
_RANGE(fam10h_HWCR,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,39,0);
_NAMES(fam10h_HWCR,"SmmLock","SlowFence",0,"TlbCacheDis","INVD_WBINVD",0,"IgnneEm","MonMwaitDis","MonMwaitUserEn","LimitCpuidStdMaxVal","HltXSpCycEn","SmiSpCycDis","RsmSpCycDis","SseDis",0,"Wrap32Dis","McStatusWrEn",0,"IoCfgGpFault","MisAlignSseDis",0,"ForceUsRdWrSzPrb","TscFreqSel",0);
_RANGE(fam10h_IORR_BASE0,3,1,1,7,36,16,0);
_NAMES(fam10h_IORR_BASE0,0,"WrMem","RdMem",0,"PhyBase",0);
_RANGE(fam10h_IORR_MASK0,11,1,36,16,0);
_NAMES(fam10h_IORR_MASK0,0,"Valid","PhyMask",0);
_RANGE(fam10h_IORR_BASE1,3,1,1,7,36,16,0);
_NAMES(fam10h_IORR_BASE1,0,"WrMem","RdMem",0,"PhyBase",0);
_RANGE(fam10h_IORR_MASK1,11,1,36,16,0);
_NAMES(fam10h_IORR_MASK1,0,"Valid","PhyMask",0);
_RANGE(fam10h_TOP_MEM,23,25,16,0);
_NAMES(fam10h_TOP_MEM,0,"TOM",0);
_RANGE(fam10h_TOM2,23,25,16,0);
_NAMES(fam10h_TOM2,0,"TOM2",0);
_RANGE(fam10h_NB_CFG,9,1,1,20,1,4,1,8,1,1,3,1,3,1,9,0);
_NAMES(fam10h_NB_CFG,0,"DisRefUseFreeBuf","DisXdsBypass",0,"DisCohLdtCfg",0,"DisDatMsk",0,"DisUsSysMgtReqToNcHt","EnableCf8ExtCfg",0,"DisOrderRdRsp",0,"InitApicIdCpuIdLo",0);
_RANGE(fam10h_MCEredirection,8,1,1,54,0);
_NAMES(fam10h_MCEredirection,"RedirVector","RedirVecEn","RedirSmiEn",0);
_RANGE(fam10h_ProcessorNameString0,64,0);
_NAMES(fam10h_ProcessorNameString0,"CpuNameString");
_RANGE(fam10h_ProcessorNameString1,64,0);
_NAMES(fam10h_ProcessorNameString1,"CpuNameString");
_RANGE(fam10h_ProcessorNameString2,64,0);
_NAMES(fam10h_ProcessorNameString2,"CpuNameString");
_RANGE(fam10h_ProcessorNameString3,64,0);
_NAMES(fam10h_ProcessorNameString3,"CpuNameString");
_RANGE(fam10h_ProcessorNameString4,64,0);
_NAMES(fam10h_ProcessorNameString4,"CpuNameString");
_RANGE(fam10h_ProcessorNameString5,64,0);
_NAMES(fam10h_ProcessorNameString5,"CpuNameString");
_RANGE(fam10h_MC0_CTL_MASK,1,1,1,1,1,1,1,57,0);
_NAMES(fam10h_MC0_CTL_MASK,"ECCI","ECCM","DECC","DMTP","DSTP","L1TP","L2TP",0);
_RANGE(fam10h_MC1_CTL_MASK,1,1,1,1,1,1,1,2,1,54,0);
_NAMES(fam10h_MC1_CTL_MASK,"ECCI","ECCM","IDP","IMTP","ISTP","L1TP","L2TP",0,"RDDE",0);
_RANGE(fam10h_MC2_CTL_MASK,1,1,1,1,1,1,1,1,1,1,1,1,52,0);
_NAMES(fam10h_MC2_CTL_MASK,"SRDE_HP","SRDE_TLB","SRDE_ALL","L2T_PAR","L2T_CECC","L2T_UECC","L2D_PAR","L2D_CECC","L2D_UECC",0,"VB_PAR","PDC_PAR",0);
_RANGE(fam10h_MC3_CTL_MASK,1,1,62,0);
_NAMES(fam10h_MC3_CTL_MASK,"SRDE_L","SRDE_S",0);
_RANGE(fam10h_MC4_CTL_MASK,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,36,0);
_NAMES(fam10h_MC4_CTL_MASK,"CECCEn","UECCEn","CrcErr0En","CrcErr1En","CrcErr2En","SyncPkt0En","SyncPkt1En","SyncPkt2En","MstrAbrtEn","TgtAbrtEn","GartTblWkEn","AtomicRMWEn","WDTRptEn","DevErrEn","L3ArrayCorEn","L3ArrayUCEn","HtProtEn","HtDataEn","DramParEn","RtryHt0En","RtryHt1En","RtryHt2En","RtryHt3En","CrcErr3En","SyncPkt3En","McaUsPwDatErrEn","NbArrayParEn","TblWlkDatErrEn",0);
_RANGE(fam10h_MC5_CTL_MASK,1,63,0);
_NAMES(fam10h_MC5_CTL_MASK,"CPUWDT",0);
_RANGE(fam10h_SMI_ON_IO_TRAP_0,32,24,5,1,1,1,0);
_NAMES(fam10h_SMI_ON_IO_TRAP_0,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam10h_SMI_ON_IO_TRAP_1,32,24,5,1,1,1,0);
_NAMES(fam10h_SMI_ON_IO_TRAP_1,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam10h_SMI_ON_IO_TRAP_2,32,24,5,1,1,1,0);
_NAMES(fam10h_SMI_ON_IO_TRAP_2,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam10h_SMI_ON_IO_TRAP_3,32,24,5,1,1,1,0);
_NAMES(fam10h_SMI_ON_IO_TRAP_3,"SmiAddr","SmiMask",0,"ConfigSmi","SmiOnWrEn","SmiOnRdEn");
_RANGE(fam10h_SMI_ON_IO_TRAP_CTL_STS,1,1,1,1,1,1,1,1,7,1,48,0);
_NAMES(fam10h_SMI_ON_IO_TRAP_CTL_STS,0,"SmiEn_0",0,"SmiEn_1",0,"SmiEn_2",0,"SmiEn_3",0,"IoTrapEn",0);
_RANGE(fam10h_IntPendingMessage,16,8,1,1,1,1,1,35,0);
_NAMES(fam10h_IntPendingMessage,"IOMsgAddr","IOMsgData","IntrPndMsgDis","IntrPndMsg","IORd","SmiOnCmpHalt","C1eOnCmpHalt",0);
_RANGE(fam10h_SmiTriggerIoCycle,16,8,1,1,1,37,0);
_NAMES(fam10h_SmiTriggerIoCycle,"IoPortAddress","IoData",0,"IoCycleEn","IoRd",0);
_RANGE(fam10h_MmioConfigBase,1,1,4,14,28,16,0);
_NAMES(fam10h_MmioConfigBase,"Enable","TrapAccess","SegBusRange",0,"MmiocCfgBaseAddr",0);
_RANGE(fam10h_PstateCurrentLimit,3,1,3,57,0);
_NAMES(fam10h_PstateCurrentLimit,"CurPstateLimit",0,"PstateMaxVal",0);
_RANGE(fam10h_PstateControl,3,61,0);
_NAMES(fam10h_PstateControl,"PstateCmd",0);
_RANGE(fam10h_PstateStatus,3,61,0);
_NAMES(fam10h_PstateStatus,"CurPstate",0);
_RANGE(fam10h_Pstate0,6,3,7,6,1,2,7,8,2,21,1,0);
_NAMES(fam10h_Pstate0,"CpuFid","CpuDid","CpuVid",0,"NbDid",0,"NbVid","IddValue","IddDiv",0,"PstateEn");
_RANGE(fam10h_Pstate1,6,3,7,6,1,2,7,8,2,21,1,0);
_NAMES(fam10h_Pstate1,"CpuFid","CpuDid","CpuVid",0,"NbDid",0,"NbVid","IddValue","IddDiv",0,"PstateEn");
_RANGE(fam10h_Pstate2,6,3,7,6,1,2,7,8,2,21,1,0);
_NAMES(fam10h_Pstate2,"CpuFid","CpuDid","CpuVid",0,"NbDid",0,"NbVid","IddValue","IddDiv",0,"PstateEn");
_RANGE(fam10h_Pstate3,6,3,7,6,1,2,7,8,2,21,1,0);
_NAMES(fam10h_Pstate3,"CpuFid","CpuDid","CpuVid",0,"NbDid",0,"NbVid","IddValue","IddDiv",0,"PstateEn");
_RANGE(fam10h_Pstate4,6,3,7,6,1,2,7,8,2,21,1,0);
_NAMES(fam10h_Pstate4,"CpuFid","CpuDid","CpuVid",0,"NbDid",0,"NbVid","IddValue","IddDiv",0,"PstateEn");
_RANGE(fam10h_COFVIDcontrol,6,3,7,3,3,1,2,7,32,0);
_NAMES(fam10h_COFVIDcontrol,"CpuFid","CpuDid","CpuVid","PstateId",0,"NbDid",0,"NbVid",0);
_RANGE(fam10h_COFVIDstatus,6,3,7,3,3,1,2,7,3,7,7,6,1,3,5,0);
_NAMES(fam10h_COFVIDstatus,"CurCpuFid","CurCpuDid","CurCpuVid","CurPstate",0,"CurNbDid",0,"CurNbVid","StartupPstate","MaxVid","MinVid","MaxCpuCof",0,"CurPstateLimit","MaxNbFid");
_RANGE(fam10h_CpuWdTmrCfg,1,2,4,57,0);
_NAMES(fam10h_CpuWdTmrCfg,"CpuWdtEn","CpuWdtTimeBase","CpuWdtCountSel",0);
_RANGE(fam10h_SMM_BASE,32,32,0);
_NAMES(fam10h_SMM_BASE,"SMM_BASE",0);
_RANGE(fam10h_SMMAddr,17,31,16,0);
_NAMES(fam10h_SMMAddr,0,"TSegBase",0);
_RANGE(fam10h_SMMMask,1,1,1,1,1,1,2,3,1,3,2,31,16,0);
_NAMES(fam10h_SMMMask,"AValid","TValid","AClose","TClose","AMTypeIoWc","TMTypeIoWc",0,"AMTypeDram",0,"TMTypeDram",0,"TSegMask",0);
_RANGE(fam10h_VM_CR,1,1,1,1,1,59,0);
_NAMES(fam10h_VM_CR,"dpd","r_init","dis_a20m","Lock","Svme_Disable",0);
_RANGE(fam10h_IGNNE,1,63,0);
_NAMES(fam10h_IGNNE,"IGNNE",0);
_RANGE(fam10h_VM_HSAVE_PA,64,0);
_NAMES(fam10h_VM_HSAVE_PA,"VM_HSAVE_PA");
_RANGE(fam10h_SMIstatus,4,4,1,1,1,5,1,1,1,1,1,1,1,41,0);
_NAMES(fam10h_SMIstatus,"IoTrapSts",0,"MceRedirSts","SmiOnCmpHaltSts","IntPendSmiSts",0,"SmiSrcLvtLcy","SmiSrcLvtExt","SmiSrcThrCntDram","SmiSrcThrCntHt","SmiSrcThrCntL3",0,"SmiSrcOnLineSpare",0);
_RANGE(fam10h_OSVW_ID_Length,16,48,0);
_NAMES(fam10h_OSVW_ID_Length,"OSVW_ID_Length",0);
_RANGE(fam10h_OsvwStatus,64,0);
_NAMES(fam10h_OsvwStatus,"OsvwStatusBits");
_RANGE(fam10h_CPUIDFeatures,32,32,0);
_NAMES(fam10h_CPUIDFeatures,"FeaturesEdx","FeaturesEcx");
_RANGE(fam10h_CPUIDExtFeatures,32,32,0);
_NAMES(fam10h_CPUIDExtFeatures,"ExtFeaturesEdx","ExtFeaturesEcx");
_RANGE(fam10h_NodeId,3,3,6,52,0);
_NAMES(fam10h_NodeId,"NodeId","NodesPerProcessor","BiosScratch",0);
_RANGE(fam10h_IC_CFG,9,1,4,1,39,0);
_NAMES(fam10h_IC_CFG,0,"DIS_SPEC_TLB_RLD",0,"DIS_IND",0);
_RANGE(fam10h_DC_CFG,4,1,3,1,4,1,20,2,28,0);
_NAMES(fam10h_DC_CFG,0,"DIS_SPEC_TLB_RLD",0,"DIS_CLR_WBTOL2_SMC_HIT",0,"DIS_HW_PF",0,"REQ_CTR",0);
_RANGE(fam10h_BU_CFG,48,1,15,0);
_NAMES(fam10h_BU_CFG,0,"WbEnhWsbDis",0);
_RANGE(fam10h_BU_CFG2,2,1,3,2,7,1,13,1,6,2,4,1,7,1,13,0);
_NAMES(fam10h_BU_CFG2,0,"FrcWTMemTypToWPDis",0,"ThrottleNbInterface",0,"CILinesToNbDis",0,"Smash1GPages",0,"ThrottleNbInterface",0,"ProbeFilterSupEn",0,"RdMmExtCfgQwEn",0);
_RANGE(fam10h_IbsFetchCtl,16,16,16,1,1,1,1,1,2,1,1,1,6,0);
_NAMES(fam10h_IbsFetchCtl,"IbsFetchMaxCnt","IbsFetchCnt","IbsFetchLat","IbsFetchEn","IbsFetchVal","IbsFetchComp","IbsIcMiss","IbsPhyAddrValid","IbsL1TlbPgSz","IbsL1TlbMiss","IbsL2TlbMiss","IbsRandEn",0);
_RANGE(fam10h_IbsFetchLinAd,64,0);
_NAMES(fam10h_IbsFetchLinAd,"IbsFetchLinAd");
_RANGE(fam10h_IbsFetchPhysAd,64,0);
_NAMES(fam10h_IbsFetchPhysAd,"IbsFetchPhysAd");
_RANGE(fam10h_IbsOpCtl,16,1,1,1,1,12,20,12,0);
_NAMES(fam10h_IbsOpCtl,"IbsOpMaxCnt",0,"IbsOpEn","IbsOpVal","IbsOpCntCtl",0,"IbsOpCurCnt",0);
_RANGE(fam10h_IbsOpRip,64,0);
_NAMES(fam10h_IbsOpRip,"IbsOpRip");
_RANGE(fam10h_IbsOpData,16,16,1,1,1,1,1,1,26,0);
_NAMES(fam10h_IbsOpData,"IbsCompToRetCtr","IbsTagToRetCtr","IbsOpBrnResync","IbsOpMispReturn","IbsOpReturn","IbsOpBrnTaken","IbsOpBrnMisp","IbsOpBrnRet",0);
_RANGE(fam10h_IbsOpData2,3,1,1,1,58,0);
_NAMES(fam10h_IbsOpData2,"NbIbsReqSrc",0,"NbIbsReqDstProc","NbIbsReqCacheHitSt",0);
_RANGE(fam10h_IbsOpData3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,12,16,16,0);
_NAMES(fam10h_IbsOpData3,"IbsLdOp","IbsStOp","IbsDcL1tlbMiss","IbsDcL2tlbMiss","IbsDcL1tlbHit2M","IbsDcL1tlbHit1G","IbsDcL2tlbHit2M","IbsDcMiss","IbsDcMisAcc","IbsDcLdBnkCon","IbsDcStBnkCon","IbsDcStToLdFwd","IbsDcStToLdCan","IbsDcUcMemAcc","IbsDcWcMemAcc","IbsDcLockedOp","IbsDcMabHit","IbsDcLinAddrValid","IbsDcPhyAddrValid","IbsDcL2tlbHit1G",0,"IbsDcMissLat",0);
_RANGE(fam10h_IbsDcLinAd,64,0);
_NAMES(fam10h_IbsDcLinAd,"IbsDcLinAd");
_RANGE(fam10h_IbsDcPhysAd,64,0);
_NAMES(fam10h_IbsDcPhysAd,"IbsDcPhysAd");
_RANGE(fam10h_IbsControl,4,4,1,55,0);
_NAMES(fam10h_IbsControl,"LvtOffset",0,"LvtOffsetVal",0);

struct reg_spec fam10h_spec [] = {
	_SPEC(0x0000, LSMCAaddr, "load-store MCA address", fam10h_),
	_SPEC(0x0001, LSMCAstatus, "load-store MCE status", fam10h_),
	_SPEC(0x0010, TSC, "time-stamp counter", fam10h_),
	_SPEC(0x001b, APIC_BASE, "APIC base address", fam10h_),
	_SPEC(0x002a, EBL_CR_POWERON, "cluster ID", fam10h_),
	_SPEC(0x008b, PATCH_LEVEL, "microcode patch level", fam10h_),
	_SPEC(0x00fe, MTRRcap, "MTRR capabilities", fam10h_),
	_SPEC(0x0174, SYSENTER_CS, "SYSENTER/SYSEXIT code segment selector", fam10h_),
	_SPEC(0x0175, SYSENTER_ESP, "SYSENTER/SYSEXIT stack pointer", fam10h_),
	_SPEC(0x0176, SYSENTER_EIP, "SYSENTER/SYSEXIT instruction pointer", fam10h_),
	_SPEC(0x0179, MCG_CAP, "global MC capabilities", fam10h_),
	_SPEC(0x017a, MCG_STAT, "global MC status", fam10h_),
	_SPEC(0x017b, MCG_CTL, "global MC control", fam10h_),
	_SPEC(0x01d9, DBG_CTL_MSR, "debug control", fam10h_),
	_SPEC(0x01db, BR_FROM, "last branch from IP", fam10h_),
	_SPEC(0x01dc, BR_TO, "last branch to IP", fam10h_),
	_SPEC(0x01dd, LastExceptionFromIP, "last exception from IP", fam10h_),
	_SPEC(0x01de, LastExceptionToIP, "last exception to IP", fam10h_),
	_SPEC(0x0200, MTRRphysBase0, "base of variable-size MTRR (0)", fam10h_),
	_SPEC(0x0201, MTRRphysMask0, "mask of variable-size MTRR (0)", fam10h_),
	_SPEC(0x0202, MTRRphysBase1, "base of variable-size MTRR (1)", fam10h_),
	_SPEC(0x0203, MTRRphysMask1, "mask of variable-size MTRR (1)", fam10h_),
	_SPEC(0x0204, MTRRphysBase2, "base of variable-size MTRR (2)", fam10h_),
	_SPEC(0x0205, MTRRphysMask2, "mask of variable-size MTRR (2)", fam10h_),
	_SPEC(0x0206, MTRRphysBase3, "base of variable-size MTRR (3)", fam10h_),
	_SPEC(0x0207, MTRRphysMask3, "mask of variable-size MTRR (3)", fam10h_),
	_SPEC(0x0208, MTRRphysBase4, "base of variable-size MTRR (4)", fam10h_),
	_SPEC(0x0209, MTRRphysMask4, "mask of variable-size MTRR (4)", fam10h_),
	_SPEC(0x020a, MTRRphysBase5, "base of variable-size MTRR (5)", fam10h_),
	_SPEC(0x020b, MTRRphysMask5, "mask of variable-size MTRR (5)", fam10h_),
	_SPEC(0x020c, MTRRphysBase6, "base of variable-size MTRR (6)", fam10h_),
	_SPEC(0x020d, MTRRphysMask6, "mask of variable-size MTRR (6)", fam10h_),
	_SPEC(0x020e, MTRRphysBase7, "base of variable-size MTRR (7)", fam10h_),
	_SPEC(0x020f, MTRRphysMask7, "mask of variable-size MTRR (7)", fam10h_),
	_SPEC(0x0250, MTRRfix64K_00000, "fixed range MTRR", fam10h_),
	_SPEC(0x0258, MTRRfix16K_80000, "fixed range MTRR", fam10h_),
	_SPEC(0x0259, MTRRfix16K_A0000, "fixed range MTRR", fam10h_),
	_SPEC(0x0268, MTRRfix4K_C0000, "fixed range MTRR", fam10h_),
	_SPEC(0x0269, MTRRfix4K_C8000, "fixed range MTRR", fam10h_),
	_SPEC(0x026a, MTRRfix4K_D0000, "fixed range MTRR", fam10h_),
	_SPEC(0x026b, MTRRfix4K_D8000, "fixed range MTRR", fam10h_),
	_SPEC(0x026c, MTRRfix4K_E0000, "fixed range MTRR", fam10h_),
	_SPEC(0x026d, MTRRfix4K_E8000, "fixed range MTRR", fam10h_),
	_SPEC(0x026e, MTRRfix4K_F0000, "fixed range MTRR", fam10h_),
	_SPEC(0x026f, MTRRfix4K_F8000, "fixed range MTRR", fam10h_),
	_SPEC(0x0277, PAT, "page attribute table", fam10h_),
	_SPEC(0x02ff, MTRRdefType, "MTRR default memory type", fam10h_),
	_SPEC(0x0400, MC0_CTL, "data cache MC control", fam10h_),
	_SPEC(0x0401, MC0_STATUS, "data cache MC status", fam10h_),
	_SPEC(0x0402, MC0_ADDR, "data cache MC address", fam10h_),
	_SPEC(0x0403, MC0_MISC, "data cache MC miscellaneous", fam10h_),
	_SPEC(0x0404, MC1_CTL, "instruction cache MC control", fam10h_),
	_SPEC(0x0405, MC1_STATUS, "instruction cache MC status", fam10h_),
	_SPEC(0x0406, MC1_ADDR, "instruction cache MC address", fam10h_),
	_SPEC(0x0407, MC1_MISC, "instruction cache MC miscellaneous", fam10h_),
	_SPEC(0x0408, MC2_CTL, "bus unit MC control", fam10h_),
	_SPEC(0x0409, MC2_STATUS, "bus unit MC status", fam10h_),
	_SPEC(0x040a, MC2_ADDR, "bus unit MC address register", fam10h_),
	_SPEC(0x040b, MC2_MISC, "bus unit MC miscellaneous", fam10h_),
	_SPEC(0x040c, MC3_CTL, "load store unit MC control", fam10h_),
	_SPEC(0x040d, MC3_STATUS, "load store unit MC status", fam10h_),
	_SPEC(0x040e, MC3_ADDR, "load store unit MC address", fam10h_),
	_SPEC(0x040f, MC3_MISC, "load store unit MC miscellaneous", fam10h_),
	_SPEC(0x0410, MC4_CTL, "northbridge MC control", fam10h_),
	_SPEC(0x0411, MC4_STATUS, "northbridge MC status", fam10h_),
	_SPEC(0x0412, MC4_ADDR, "northbridge MC address", fam10h_),
	_SPEC(0x0413, MC4_MISC0, "northbridge MC misc (thresholding) (0 - DRAM)", fam10h_),
	_SPEC(0x0414, MC5_CTL, "fixed issue reorder buffer MC control", fam10h_),
	_SPEC(0x0415, MC5_STATUS, "fixed issue reorder buffer MC status", fam10h_),
	_SPEC(0x0416, MC5_ADDR, "fixed issue reorder buffer MC address", fam10h_),
	_SPEC(0x0417, MC5_MISC, "fixed issue reorder buffer MC miscellaneous", fam10h_),
	_SPEC(0xc0000080, EFER, "extended feature enable", fam10h_),
	_SPEC(0xc0000081, STAR, "SYSCALL target address", fam10h_),
	_SPEC(0xc0000082, STAR64, "long mode SYSCALL target address", fam10h_),
	_SPEC(0xc0000083, STARCOMPAT, "compat mode SYSCALL target address", fam10h_),
	_SPEC(0xc0000084, SYSCALL_FLAG_MASK, "SYSCALL flag mask", fam10h_),
	_SPEC(0xc0000100, FS_BASE, "FS base", fam10h_),
	_SPEC(0xc0000101, GS_BASE, "GS base", fam10h_),
	_SPEC(0xc0000102, KernelGSbase, "kernel GS base", fam10h_),
	_SPEC(0xc0000103, TSC_AUX, "auxiliary time stamp counter data", fam10h_),
	_SPEC(0xc0000408, MC4_MISC1, "northbridge MC misc (thresholding) (1 - link)", fam10h_),
	_SPEC(0xc0000409, MC4_MISC2, "northbridge MC misc (thresholding) (2 - L3 cache)", fam10h_),
	_SPEC(0xc000040a, MC4_MISC3, "northbridge MC misc (thresholding) (3)", fam10h_),
	_SPEC(0xc0010000, PERF_CTL0, "performance event select (0)", fam10h_),
	_SPEC(0xc0010001, PERF_CTL1, "performance event select (1)", fam10h_),
	_SPEC(0xc0010002, PERF_CTL2, "performance event select (2)", fam10h_),
	_SPEC(0xc0010003, PERF_CTL3, "performance event select (3)", fam10h_),
	_SPEC(0xc0010004, PERF_CTR0, "performance event counter (0)", fam10h_),
	_SPEC(0xc0010005, PERF_CTR1, "performance event counter (1)", fam10h_),
	_SPEC(0xc0010006, PERF_CTR2, "performance event counter (2)", fam10h_),
	_SPEC(0xc0010007, PERF_CTR3, "performance event counter (3)", fam10h_),
	_SPEC(0xc0010010, SYS_CFG, "system configuration", fam10h_),
	_SPEC(0xc0010015, HWCR, "hardware configuration", fam10h_),
	_SPEC(0xc0010016, IORR_BASE0, "base of variable I/O range (0)", fam10h_),
	_SPEC(0xc0010017, IORR_MASK0, "mask of variable I/O range (0)", fam10h_),
	_SPEC(0xc0010018, IORR_BASE1, "base of variable I/O range (1)", fam10h_),
	_SPEC(0xc0010019, IORR_MASK1, "mask of variable I/O range (1)", fam10h_),
	_SPEC(0xc001001a, TOP_MEM, "top of memory address", fam10h_),
	_SPEC(0xc001001d, TOM2, "second top of memory address", fam10h_),
	_SPEC(0xc001001f, NB_CFG, "northbridge configuration", fam10h_),
	_SPEC(0xc0010022, MCEredirection, "MCE redirection", fam10h_),
	_SPEC(0xc0010030, ProcessorNameString0, "processor name string (0)", fam10h_),
	_SPEC(0xc0010031, ProcessorNameString1, "processor name string (1)", fam10h_),
	_SPEC(0xc0010032, ProcessorNameString2, "processor name string (2)", fam10h_),
	_SPEC(0xc0010033, ProcessorNameString3, "processor name string (3)", fam10h_),
	_SPEC(0xc0010034, ProcessorNameString4, "processor name string (4)", fam10h_),
	_SPEC(0xc0010035, ProcessorNameString5, "processor name string (5)", fam10h_),
	_SPEC(0xc0010044, MC0_CTL_MASK, "data cache MC control mask", fam10h_),
	_SPEC(0xc0010045, MC1_CTL_MASK, "instruction cache MC control mask", fam10h_),
	_SPEC(0xc0010046, MC2_CTL_MASK, "bus unit MC control mask", fam10h_),
	_SPEC(0xc0010047, MC3_CTL_MASK, "load store unit MC control mask", fam10h_),
	_SPEC(0xc0010048, MC4_CTL_MASK, "northbridge MC control mask", fam10h_),
	_SPEC(0xc0010049, MC5_CTL_MASK, "fixed issue reorder buffer MC control mask", fam10h_),
	_SPEC(0xc0010050, SMI_ON_IO_TRAP_0, "IO trap address (0)", fam10h_),
	_SPEC(0xc0010051, SMI_ON_IO_TRAP_1, "IO trap address (1)", fam10h_),
	_SPEC(0xc0010052, SMI_ON_IO_TRAP_2, "IO trap address (2)", fam10h_),
	_SPEC(0xc0010053, SMI_ON_IO_TRAP_3, "IO trap address (3)", fam10h_),
	_SPEC(0xc0010054, SMI_ON_IO_TRAP_CTL_STS, "IO trap control", fam10h_),
	_SPEC(0xc0010055, IntPendingMessage, "interrupt pending and CMP-halt", fam10h_),
	_SPEC(0xc0010056, SmiTriggerIoCycle, "SMI trigger IO cycle", fam10h_),
	_SPEC(0xc0010058, MmioConfigBase, "MMIO configuration base address", fam10h_),
	_SPEC(0xc0010061, PstateCurrentLimit, "P-state current limit", fam10h_),
	_SPEC(0xc0010062, PstateControl, "P-state control", fam10h_),
	_SPEC(0xc0010063, PstateStatus, "P-state status", fam10h_),
	_SPEC(0xc0010064, Pstate0, "P-state 0", fam10h_),
	_SPEC(0xc0010065, Pstate1, "P-state 1", fam10h_),
	_SPEC(0xc0010066, Pstate2, "P-state 2", fam10h_),
	_SPEC(0xc0010067, Pstate3, "P-state 3", fam10h_),
	_SPEC(0xc0010068, Pstate4, "P-state 4", fam10h_),
	_SPEC(0xc0010070, COFVIDcontrol, "COFVID control", fam10h_),
	_SPEC(0xc0010071, COFVIDstatus, "COFVID status", fam10h_),
	_SPEC(0xc0010074, CpuWdTmrCfg, "CPU watchdog timer", fam10h_),
	_SPEC(0xc0010111, SMM_BASE, "SMM base address", fam10h_),
	_SPEC(0xc0010112, SMMAddr, "SMM TSeg base address", fam10h_),
	_SPEC(0xc0010113, SMMMask, "SMM Tseg mask", fam10h_),
	_SPEC(0xc0010114, VM_CR, "virtual machine control", fam10h_),
	_SPEC(0xc0010115, IGNNE, "IGNNE", fam10h_),
	_SPEC(0xc0010117, VM_HSAVE_PA, "virtual machine host save physical address", fam10h_),
	_SPEC(0xc001011a, SMIstatus, "local SMI status", fam10h_),
	_SPEC(0xc0010140, OSVW_ID_Length, "OS visible work-around", fam10h_),
	_SPEC(0xc0010141, OsvwStatus, "OS visible work-around status bits", fam10h_),
	_SPEC(0xc0011004, CPUIDFeatures, "CPUID features", fam10h_),
	_SPEC(0xc0011005, CPUIDExtFeatures, "extended CPUID features", fam10h_),
	_SPEC(0xc001100c, NodeId, "Node ID", fam10h_),
	_SPEC(0xc0011021, IC_CFG, "instruction cache configuration", fam10h_),
	_SPEC(0xc0011022, DC_CFG, "data cache configuration", fam10h_),
	_SPEC(0xc0011023, BU_CFG, "bus unit configuration", fam10h_),
	_SPEC(0xc001102A, BU_CFG2, "bus unit configuration 2", fam10h_),
	_SPEC(0xc0011030, IbsFetchCtl, "IBS fetch control", fam10h_),
	_SPEC(0xc0011031, IbsFetchLinAd, "IBS fetch linear address", fam10h_),
	_SPEC(0xc0011032, IbsFetchPhysAd, "IBS fetch physical address", fam10h_),
	_SPEC(0xc0011033, IbsOpCtl, "IBS execution control", fam10h_),
	_SPEC(0xc0011034, IbsOpRip, "IBS Op logical address", fam10h_),
	_SPEC(0xc0011035, IbsOpData, "IBS Op data", fam10h_),
	_SPEC(0xc0011036, IbsOpData2, "IBS Op data 2", fam10h_),
	_SPEC(0xc0011037, IbsOpData3, "IBS Op data 3", fam10h_),
	_SPEC(0xc0011038, IbsDcLinAd, "IBS DC linear address", fam10h_),
	_SPEC(0xc0011039, IbsDcPhysAd, "IBS DC physical address", fam10h_),
	_SPEC(0xc001103a, IbsControl, "IBS control", fam10h_),
	{0, NULL, NULL, NULL, NULL},
};

#endif /* fam10h_h */
