/*
 * Licensed under the terms of the GNU GENERAL PUBLIC LICENSE version 2.
 * See file COPYING for details.
 */

#ifndef generic_msr_h
#define generic_msr_h

#include "msr.h"

_RANGE(generic_msr_TSC,64,0);
_NAMES(generic_msr_TSC,"TSC");
_RANGE(generic_msr_APIC_BASE,8,1,2,1,36,16,0);
_NAMES(generic_msr_APIC_BASE,0,"BSC",0,"ApicEn","ApicBar",0);
_RANGE(generic_msr_EBL_CR_POWERON,16,2,46,0);
_NAMES(generic_msr_EBL_CR_POWERON,0,"ClusterID",0);
_RANGE(generic_msr_MTRRcap,8,1,1,1,53,0);
_NAMES(generic_msr_MTRRcap,"MtrrCapVCnt","MtrrCapFix",0,"MtrrCapWc",0);
_RANGE(generic_msr_MCG_CAP,8,1,55,0);
_NAMES(generic_msr_MCG_CAP,"Count","MCG_CTL_P",0);
_RANGE(generic_msr_MCG_STAT,1,1,1,61,0);
_NAMES(generic_msr_MCG_STAT,"RIPV","EIPV","MCIP",0);
_RANGE(generic_msr_MCG_CTL,64,0);
_NAMES(generic_msr_MCG_CTL,"val");
_RANGE(generic_msr_DBG_CTL_MSR,1,1,62,0);
_NAMES(generic_msr_DBG_CTL_MSR,"LBR","BTF",0);
_RANGE(generic_msr_LastBranchFromIP,64,0);
_NAMES(generic_msr_LastBranchFromIP,"LastBranchFromIP");
_RANGE(generic_msr_LastBranchToIP,64,0);
_NAMES(generic_msr_LastBranchToIP,"LastBranchToIP");
_RANGE(generic_msr_LastExceptionFromIP,64,0);
_NAMES(generic_msr_LastExceptionFromIP,"LastExceptionFromIP");
_RANGE(generic_msr_LastExceptionToIP,64,0);
_NAMES(generic_msr_LastExceptionToIP,"LastExceptionToIP");
_RANGE(generic_msr_MTRRphysBase0,8,4,36,16,0);
_NAMES(generic_msr_MTRRphysBase0,"MemType",0,"PhyBase",0);
_RANGE(generic_msr_MTRRphysMask0,11,1,36,16,0);
_NAMES(generic_msr_MTRRphysMask0,0,"Valid","PhysMask",0);
_RANGE(generic_msr_MTRRphysBase1,8,4,36,16,0);
_NAMES(generic_msr_MTRRphysBase1,"MemType",0,"PhyBase",0);
_RANGE(generic_msr_MTRRphysMask1,11,1,36,16,0);
_NAMES(generic_msr_MTRRphysMask1,0,"Valid","PhysMask",0);
_RANGE(generic_msr_MTRRphysBase2,8,4,36,16,0);
_NAMES(generic_msr_MTRRphysBase2,"MemType",0,"PhyBase",0);
_RANGE(generic_msr_MTRRphysMask2,11,1,36,16,0);
_NAMES(generic_msr_MTRRphysMask2,0,"Valid","PhysMask",0);
_RANGE(generic_msr_MTRRphysBase3,8,4,36,16,0);
_NAMES(generic_msr_MTRRphysBase3,"MemType",0,"PhyBase",0);
_RANGE(generic_msr_MTRRphysMask3,11,1,36,16,0);
_NAMES(generic_msr_MTRRphysMask3,0,"Valid","PhysMask",0);
_RANGE(generic_msr_MTRRphysBase4,8,4,36,16,0);
_NAMES(generic_msr_MTRRphysBase4,"MemType",0,"PhyBase",0);
_RANGE(generic_msr_MTRRphysMask4,11,1,36,16,0);
_NAMES(generic_msr_MTRRphysMask4,0,"Valid","PhysMask",0);
_RANGE(generic_msr_MTRRphysBase5,8,4,36,16,0);
_NAMES(generic_msr_MTRRphysBase5,"MemType",0,"PhyBase",0);
_RANGE(generic_msr_MTRRphysMask5,11,1,36,16,0);
_NAMES(generic_msr_MTRRphysMask5,0,"Valid","PhysMask",0);
_RANGE(generic_msr_MTRRphysBase6,8,4,36,16,0);
_NAMES(generic_msr_MTRRphysBase6,"MemType",0,"PhyBase",0);
_RANGE(generic_msr_MTRRphysMask6,11,1,36,16,0);
_NAMES(generic_msr_MTRRphysMask6,0,"Valid","PhysMask",0);
_RANGE(generic_msr_MTRRphysBase7,8,4,36,16,0);
_NAMES(generic_msr_MTRRphysBase7,"MemType",0,"PhyBase",0);
_RANGE(generic_msr_MTRRphysMask7,11,1,36,16,0);
_NAMES(generic_msr_MTRRphysMask7,0,"Valid","PhysMask",0);
_RANGE(generic_msr_MTRRfix64K_00000,8,8,8,8,8,8,8,8,0);
_NAMES(generic_msr_MTRRfix64K_00000,"0xxxxType","1xxxxType","2xxxxType","3xxxxType","4xxxxType","5xxxxType","6xxxxType","7xxxxType");
_RANGE(generic_msr_MTRRfix16K_80000,8,8,8,8,8,8,8,8,0);
_NAMES(generic_msr_MTRRfix16K_80000,"80xxxType","84xxxType","88xxxType","8CxxxType","90xxxType","94xxxType","98xxxType","9CxxxType");
_RANGE(generic_msr_MTRRfix16K_A0000,8,8,8,8,8,8,8,8,0);
_NAMES(generic_msr_MTRRfix16K_A0000,"A0xxxType","A4xxxType","A8xxxType","ACxxxType","B0xxxType","B4xxxType","B8xxxType","BCxxxType");
_RANGE(generic_msr_MTRRfix4K_C0000,8,8,8,8,8,8,8,8,0);
_NAMES(generic_msr_MTRRfix4K_C0000,"C0xxxType","C1xxxType","C2xxxType","C3xxxType","C4xxxType","C5xxxType","C6xxxType","C7xxxType");
_RANGE(generic_msr_MTRRfix4K_C8000,8,8,8,8,8,8,8,8,0);
_NAMES(generic_msr_MTRRfix4K_C8000,"C8xxxType","C9xxxType","CAxxxType","CBxxxType","CCxxxType","CDxxxType","CExxxType","CFxxxType");
_RANGE(generic_msr_MTRRfix4K_D0000,8,8,8,8,8,8,8,8,0);
_NAMES(generic_msr_MTRRfix4K_D0000,"D0xxxType","D1xxxType","D2xxxType","D3xxxType","D4xxxType","D5xxxType","D6xxxType","D7xxxType");
_RANGE(generic_msr_MTRRfix4K_D8000,8,8,8,8,8,8,8,8,0);
_NAMES(generic_msr_MTRRfix4K_D8000,"D8xxxType","D9xxxType","DAxxxType","DBxxxType","DCxxxType","DDxxxType","DExxxType","DFxxxType");
_RANGE(generic_msr_MTRRfix4K_E0000,8,8,8,8,8,8,8,8,0);
_NAMES(generic_msr_MTRRfix4K_E0000,"E0xxxType","E1xxxType","E2xxxType","E3xxxType","E4xxxType","E5xxxType","E6xxxType","E7xxxType");
_RANGE(generic_msr_MTRRfix4K_E8000,8,8,8,8,8,8,8,8,0);
_NAMES(generic_msr_MTRRfix4K_E8000,"E8xxxType","E9xxxType","EAxxxType","EBxxxType","ECxxxType","EDxxxType","EExxxType","EFxxxType");
_RANGE(generic_msr_MTRRfix4K_F0000,8,8,8,8,8,8,8,8,0);
_NAMES(generic_msr_MTRRfix4K_F0000,"F0xxxType","F1xxxType","F2xxxType","F3xxxType","F4xxxType","F5xxxType","F6xxxType","F7xxxType");
_RANGE(generic_msr_MTRRfix4K_F8000,8,8,8,8,8,8,8,8,0);
_NAMES(generic_msr_MTRRfix4K_F8000,"F8xxxType","F9xxxType","FAxxxType","FBxxxType","FCxxxType","FDxxxType","FExxxType","FFxxxType");
_RANGE(generic_msr_PAT,3,5,3,5,3,5,3,5,3,5,3,5,3,5,3,5,0);
_NAMES(generic_msr_PAT,"PA0MemType",0,"PA1MemType",0,"PA2MemType",0,"PA3MemType",0,"PA4MemType",0,"PA5MemType",0,"PA6MemType",0,"PA7MemType",0);
_RANGE(generic_msr_MTRRdefType,8,2,1,1,52,0);
_NAMES(generic_msr_MTRRdefType,"MemType",0,"MtrrDefTypeFixEn","MtrrDefTypeEn",0);
_RANGE(generic_msr_EFER,1,7,1,1,1,1,52,0);
_NAMES(generic_msr_EFER,"SYSCALL",0,"LME",0,"LMA","NXE",0);
_RANGE(generic_msr_STAR,32,16,16,0);
_NAMES(generic_msr_STAR,"res","SysCallSel","SysRetSel");
_RANGE(generic_msr_LSTAR,64,0);
_NAMES(generic_msr_LSTAR,"LSTAR");
_RANGE(generic_msr_SYSCALL_FLAG_MASK,32,32,0);
_NAMES(generic_msr_SYSCALL_FLAG_MASK,"MASK",0);
_RANGE(generic_msr_FS_BASE,64,0);
_NAMES(generic_msr_FS_BASE,"FS_BASE");
_RANGE(generic_msr_GS_BASE,64,0);
_NAMES(generic_msr_GS_BASE,"GS_BASE");
_RANGE(generic_msr_KernelGSbase,64,0);
_NAMES(generic_msr_KernelGSbase,"KernelGSBase");

struct reg_spec generic_msr_spec [] = {
	_SPEC(0x0010, TSC, "time-stamp counter", generic_msr_),
	_SPEC(0x001b, APIC_BASE, "APIC base address", generic_msr_),
	_SPEC(0x002a, EBL_CR_POWERON, "cluster ID", generic_msr_),
	_SPEC(0x00fe, MTRRcap, "MTRR capabilities", generic_msr_),
	_SPEC(0x0179, MCG_CAP, "global MC capabilities", generic_msr_),
	_SPEC(0x017a, MCG_STAT, "global MC status", generic_msr_),
	_SPEC(0x017b, MCG_CTL, "global MC control", generic_msr_),
	_SPEC(0x01d9, DBG_CTL_MSR, "debug control", generic_msr_),
	_SPEC(0x01db, LastBranchFromIP, "last branch from IP", generic_msr_),
	_SPEC(0x01dc, LastBranchToIP, "last branch to IP", generic_msr_),
	_SPEC(0x01dd, LastExceptionFromIP, "last exception from IP", generic_msr_),
	_SPEC(0x01de, LastExceptionToIP, "last exception to IP", generic_msr_),
	_SPEC(0x0200, MTRRphysBase0, "base of variable-size MTRR (0)", generic_msr_),
	_SPEC(0x0201, MTRRphysMask0, "mask of variable-size MTRR (0)", generic_msr_),
	_SPEC(0x0202, MTRRphysBase1, "base of variable-size MTRR (1)", generic_msr_),
	_SPEC(0x0203, MTRRphysMask1, "mask of variable-size MTRR (1)", generic_msr_),
	_SPEC(0x0204, MTRRphysBase2, "base of variable-size MTRR (2)", generic_msr_),
	_SPEC(0x0205, MTRRphysMask2, "mask of variable-size MTRR (2)", generic_msr_),
	_SPEC(0x0206, MTRRphysBase3, "base of variable-size MTRR (3)", generic_msr_),
	_SPEC(0x0207, MTRRphysMask3, "mask of variable-size MTRR (3)", generic_msr_),
	_SPEC(0x0208, MTRRphysBase4, "base of variable-size MTRR (4)", generic_msr_),
	_SPEC(0x0209, MTRRphysMask4, "mask of variable-size MTRR (4)", generic_msr_),
	_SPEC(0x020a, MTRRphysBase5, "base of variable-size MTRR (5)", generic_msr_),
	_SPEC(0x020b, MTRRphysMask5, "mask of variable-size MTRR (5)", generic_msr_),
	_SPEC(0x020c, MTRRphysBase6, "base of variable-size MTRR (6)", generic_msr_),
	_SPEC(0x020d, MTRRphysMask6, "mask of variable-size MTRR (6)", generic_msr_),
	_SPEC(0x020e, MTRRphysBase7, "base of variable-size MTRR (7)", generic_msr_),
	_SPEC(0x020f, MTRRphysMask7, "mask of variable-size MTRR (7)", generic_msr_),
	_SPEC(0x0250, MTRRfix64K_00000, "fixed range MTRR", generic_msr_),
	_SPEC(0x0258, MTRRfix16K_80000, "fixed range MTRR", generic_msr_),
	_SPEC(0x0259, MTRRfix16K_A0000, "fixed range MTRR", generic_msr_),
	_SPEC(0x0268, MTRRfix4K_C0000, "fixed range MTRR", generic_msr_),
	_SPEC(0x0269, MTRRfix4K_C8000, "fixed range MTRR", generic_msr_),
	_SPEC(0x026a, MTRRfix4K_D0000, "fixed range MTRR", generic_msr_),
	_SPEC(0x026b, MTRRfix4K_D8000, "fixed range MTRR", generic_msr_),
	_SPEC(0x026c, MTRRfix4K_E0000, "fixed range MTRR", generic_msr_),
	_SPEC(0x026d, MTRRfix4K_E8000, "fixed range MTRR", generic_msr_),
	_SPEC(0x026e, MTRRfix4K_F0000, "fixed range MTRR", generic_msr_),
	_SPEC(0x026f, MTRRfix4K_F8000, "fixed range MTRR", generic_msr_),
	_SPEC(0x0277, PAT, "page attribute table", generic_msr_),
	_SPEC(0x02ff, MTRRdefType, "MTRR default memory type", generic_msr_),
	_SPEC(0xc0000080, EFER, "extended feature enable", generic_msr_),
	_SPEC(0xc0000081, STAR, "SYSCALL target address", generic_msr_),
	_SPEC(0xc0000082, LSTAR, "long mode SYSCALL target address", generic_msr_),
	_SPEC(0xc0000084, SYSCALL_FLAG_MASK, "SYSCALL flag mask", generic_msr_),
	_SPEC(0xc0000100, FS_BASE, "FS base", generic_msr_),
	_SPEC(0xc0000101, GS_BASE, "GS base", generic_msr_),
	_SPEC(0xc0000102, KernelGSbase, "kernel GS base", generic_msr_),
	{0, NULL, NULL, NULL, NULL},
};

#endif /* generic_msr_h */
